myGame.WalktoCommute.prototype = {
  preload: function() {
    // Preload images for this state
  },

  create: function() {
    // Background
    if (myGame.timeOfDay == "day") {

      if (myGame.day == 5) {
        this.stage.backgroundColor = '#2cb1e5';
      } else {
        this.stage.backgroundColor = '#49c4ea';
      }

        // Music
        myGame.setupAudio();
        myGame.music.commuteMorning.play('',0,1,true);

    } else {
      //Audio
      if (!myGame.music.commuteEvening.isPlaying) {
        myGame.music.commuteEvening.play('',0,1,true);
      }

      if (myGame.player.outLate) {
        this.stage.backgroundColor = '#113160';
      } else {
        this.stage.backgroundColor = '#405684';
      }
    }

    myGame.player.moveSpeed = 600;

    // Set world bounds
    this.world.setBounds(0, 0, game.width, 3150);

    this.timerText = game.add.text(game.width/2, 160, '', myGame.timerTextStyle);
    this.timerText.anchor.setTo(0.5);
    this.timerText.fixedToCamera = true;
    this.stepsTaken = 0;

    this.drawGameMap();

    myGame.setupDialog();

    // Timer
    if (myGame.timeOfDay == "day") {
      myGame.setupTimer(this);
    }

    // Setup quit button
    myGame.setupQuitButton(this);
  },

  update: function() {

    // Timer
    if (myGame.timeOfDay == "day") {
      if (!myGame.dialogWindow.visible) {
        myGame.timerBase.tint = 0xFFFFFF;
        myGame.updateTimer();
      } else {
        myGame.timerBase.tint = 0x999999;
      }

      this.monitorTime();
    }

    if (myGame.player.movable && !this.walkButtonsVisible) {
      this.toggleButtons(true);
    } else if (!myGame.player.movable && this.walkButtonsVisible) {
      this.toggleButtons(false);
    }
  },

  drawPlayer: function () {
    // Create player
    this.walkPlayer = game.add.group();

    // Body
    this.walkPlayerBody = this.walkPlayer.create(this.walkPoints.children[0].x, this.walkPoints.children[0].y, 'baseCharacter_content');
    this.walkPlayerBody.scale.x = 0.2;
    this.walkPlayerBody.scale.y = 0.2;

    // Create clothes
    var walkPlayerBottom = this.walkPlayer.create(this.walkPlayerBody.x, this.walkPlayerBody.y + myGame.outfit.bottom.location * (this.walkPlayerBody.scale.x*2), myGame.outfit.bottom.name);
    var walkPlayerTop = this.walkPlayer.create(this.walkPlayerBody.x, this.walkPlayerBody.y + myGame.outfit.top.location * (this.walkPlayerBody.scale.x*2), myGame.outfit.top.name);
    var walkPlayerHair = this.walkPlayer.create(this.walkPlayerBody.x, this.walkPlayerBody.y - myGame.outfit.hair.location * (this.walkPlayerBody.scale.x*2), myGame.outfit.hair.name);
    var walkPlayerShoes = this.walkPlayer.create(this.walkPlayerBody.x, this.walkPlayerBody.y + myGame.outfit.shoes.location * (this.walkPlayerBody.scale.x*2), myGame.outfit.shoes.name);

    // Scale clothes
    this.walkPlayer.forEach(function(item){
      item.scale.x = 0.2;
      item.scale.y = 0.2;
      item.anchor.setTo(.5, 0);
    });

    walkPlayerShoes.anchor.setTo(.5, 1);

    this.walkPlayer.pivot.y = 300;

    // Follow player
    this.camera.follow(this.walkPlayerBody);
  },

  drawGameMap: function(){
    this.walkLines = game.add.group();
    this.walkLines.create(game.world.width/2, 1138, 'walkLineStraight');
    this.walkLines.create(game.world.width/2, 2425, 'walkLineStraight');
    this.walkLines.create(430, 1558, 'walkLineCurvedLeft');
    this.walkLines.create(1170, 1558, 'walkLineCurvedRight');
    this.walkLines.create(430, 2855, 'walkLineCurvedLeft');
    this.walkLines.create(1170, 2855, 'walkLineCurvedRight');

    this.walkLines.forEach(function(line){
      line.anchor.setTo(0.5, 0.5);
    });

    // Place points on map in order depending on time
    this.walkPoints = game.add.group();
    if (myGame.timeOfDay == "day") {
      this.walkPoints.create(game.world.width/2, 620, 'walkPoint');
      this.walkPoints.create(game.world.width/2, 1700, 'walkPoint');
      this.walkPoints.create(game.world.width/2, 2980, 'walkPoint');
      this.walkPoints.create(1455, 2980, 'walkPoint');
    } else {
      this.walkPoints.create(1455, 2980, 'walkPoint');
      this.walkPoints.create(game.world.width/2, 2980, 'walkPoint');
      this.walkPoints.create(game.world.width/2, 1700, 'walkPoint');
      this.walkPoints.create(game.world.width/2, 620, 'walkPoint');
    }

    // Name walkpoints
    this.walkPoints.forEach(function(point){
      point.name = "point" + this.walkPoints.getChildIndex(point);
      point.anchor.setTo(0.5, 0.5);
    }, this);

    // Place homes
    this.goalHome = this.add.sprite(game.world.width/2,35, 'walkGoalHome').anchor.setTo(0.5,0.5);
    this.catcallerHouse1 = this.add.sprite(136,1082, 'catcallerHouse1').anchor.setTo(0.5,0.5);
    this.catcallerHouse2 = this.add.sprite(1462,1082, 'catcallerHouse2').anchor.setTo(0.5,0.5);
    this.catcallerHouse3 = this.add.sprite(136,2376, 'catcallerHouse3').anchor.setTo(0.5,0.5);
    this.goalStation = this.add.sprite(1405,2590, 'walkGoalStation').anchor.setTo(0.5,0.5);
    this.walkPointGoal = this.add.sprite(this.walkPoints.children[3].x,this.walkPoints.children[3].y, 'walkPointGoal');
    this.walkPointGoal.anchor.setTo(0.5,0.5);

    // Prompt text
    myGame.dialogHeader = game.add.sprite( 0, 0, 'dialogLocationHeader');
    myGame.dialogHeader.fixedToCamera = true;

    if (myGame.timeOfDay == 'day') {
      var goalLocation = 'to the train';
    } else {
      var goalLocation = 'home';
    }

    myGame.drawPromptText('Get ' + goalLocation);

    // Draw player
    this.drawPlayer();

    // Buttons
    this.walkDownButton = game.add.button(game.world.width/2, this.camera.height - 81, 'walkDownButton', this.movePlayer, this, 0, 1, 2);
    this.walkDownButton.anchor.setTo(0.5, 0.5);
    this.walkDownButton.fixedToCamera = true;

    this.walkRightButton = game.add.button(game.world.width/2, this.camera.height - 81, 'walkRightButton', this.movePlayer, this, 0, 1, 2);
    this.walkRightButton.anchor.setTo(0.5, 0.5);
    this.walkRightButton.fixedToCamera = true;

    if (myGame.timeOfDay != 'day') {
      this.walkDownButton.scale.y = -1;
      this.walkRightButton.scale.x = -1;
    }

    // Catcaller location
    var catcallerLocationNumber = this.rnd.integerInRange(1, 3);
    var catcallerX;
    var catcallerY;
    switch (catcallerLocationNumber){
      case 1:
      catcallerX = 136;
      catcallerY = 1540;
      break;
      case 2:
      catcallerX = 1462;
      catcallerY = 1540;
      break;
      default:
      catcallerX = 136;
      catcallerY = 2835;
      break;
    }


    var catcaller1Texture;
    var catcaller2Texture;
    var catcallerTriggerNumber = this.rnd.integerInRange(1, 2);

    this.catcaller = this.add.sprite(catcallerX, catcallerY, 'speaker-image-catcaller' + myGame.day * catcallerTriggerNumber);
    this.catcaller.number = catcallerTriggerNumber;

    // If catcaller is triggered
    if (this.catcaller) {
      this.catcaller.anchor.setTo(0.5, 0.5);
      this.catcaller.scale.x = 0.25;
      this.catcaller.scale.y = 0.25;
      if (myGame.timeOfDay == "day" && (catcallerLocationNumber == 1 ||  catcallerLocationNumber == 2)) {
        this.walkPoints.children[1].dangerous = true;
        this.walkPoints.children[1].catcallTriggered = false;
      } else if (myGame.timeOfDay == "day") {
        this.walkPoints.children[2].dangerous = true;
        this.walkPoints.children[2].catcallTriggered = false;
      } else if (myGame.timeOfDay == "night" && (catcallerLocationNumber == 1 ||  catcallerLocationNumber == 2)){
        this.walkPoints.children[2].dangerous = true;
        this.walkPoints.children[2].catcallTriggered = false;
      } else {
        this.walkPoints.children[1].dangerous = true;
        this.walkPoints.children[1].catcallTriggered = false;
      }
    }

    // Move text to top
    this.walkTextGroup = game.add.group();
    this.walkTextGroup.add(myGame.dialogHeader);
    this.walkTextGroup.add(myGame.PromptText);
    this.walkTextGroup.add(this.timerText);

    // Check location
    this.checkPlayerLocation();
  },

  checkOverlap: function(spriteA, spriteB) {
    var boundsA = spriteA.getBounds();
    var boundsB = spriteB.getBounds();

    return Phaser.Rectangle.intersects(boundsA, boundsB);
  },

  checkPlayerLocation: function() {
    this.toggleButtons(true);
    this.triggerRandomCatcall();

    if (this.walkPlayerBody.x == this.walkPointGoal.x && this.walkPlayerBody.y == this.walkPointGoal.y) {
      this.continue();
    }

  },

  triggerRandomCatcall: function() {
    this.walkPoints.forEach(function(point){

      // Detect if player is on a point
      if (point.x == this.walkPlayerBody.x && point.y == this.walkPlayerBody.y){

        // Detect if player is on dangerous point
        if (point.dangerous && !point.catcallTriggered) {
          var randomNumber;
          switch (myGame.player.style) {
            case "sexy":
            randomNumber = 2;
            break;
            case "cute":
            randomNumber = this.rnd.integerInRange(1, 2);
            break;
            case "outlandish":
            randomNumber = this.rnd.integerInRange(1, 3);
            break;
            default:
            randomNumber = this.rnd.integerInRange(1, 4);
            break;
          }

          // Detect if catcall was triggered
          if (randomNumber == 2 || myGame.isDebugging) {
            point.catcallTriggered = true;

            this.triggeredPointName = point.name;

            var catcallerExclamation = game.add.sprite(this.catcaller.x, this.catcaller.y - (this.catcaller.height) + 100, 'catcallerExclamation')
            catcallerExclamation.anchor.setTo(0.5, 0);
            catcallerExclamation.alpha = 0;
            var catcallerExclamationTween = game.add.tween(catcallerExclamation);
            catcallerExclamationTween.to( { alpha: 1 }, 100).to( { y: catcallerExclamation.y - 15 }, 400).to( { alpha: 0 }, 100).start();

            this.showPlayerExclamation();

            // Dialog
            this.dialogJSON = game.cache.getJSON('dialog_walk_' + myGame.timeOfDay + '_' + (myGame.day * this.catcaller.number));
            this.dialog = {};
            this.dialog = this.dialogJSON.content;
            this.dialogLength = Object.keys(this.dialog).length - 1;
            this.completedDialog = 0;
            myGame.setupDialog(this.dialog);

            // Delay before showing dialog
            this.time.events.add(Phaser.Timer.SECOND/2, function(){
              myGame.dialogGroup.forEach(function(item) {
                item.y += game.camera.y;
              });
              myGame.startDialogAtID(this);
            }, this);

          } else {
            myGame.player.movable = true;
          }
        } else {
          myGame.player.movable = true;
        }
      }
    }, this);
  },

  toggleButtons(visible) {
    if (visible == true) {
      this.walkButtonsVisible = visible;
      if (myGame.timeOfDay == "day") {

        if (this.stepsTaken < 2) {
          this.walkDownButton.visible = true;
          this.walkRightButton.visible = false;
        } else {
          this.walkDownButton.visible = false;
          this.walkRightButton.visible = true;
        }
      } else {
        if (this.stepsTaken > 0) {
          this.walkDownButton.visible = true;
          this.walkRightButton.visible = false;
        } else {
          this.walkDownButton.visible = false;
          this.walkRightButton.visible = true;
        }
      }
    } else {
      this.walkButtonsVisible = false;
      this.walkDownButton.visible = false;
      this.walkRightButton.visible = false;
    }
  },

  movePlayer: function() {
    myGame.sounds.dialog.buttonClick1.play();
    myGame.sounds.map.steps.play();

    this.stepsTaken++;
    var walkTweens = [];

    var parentGroup = this.walkPlayer;

    this.walkPlayer.forEach(function(item){
     var childIndex = parentGroup.getChildIndex(item);
     walkTweens[childIndex] = game.add.tween(item);
   });

    if (!walkTweens[0].isRunning && myGame.player.movable) {
      walkTweens[0].to({x: this.walkPoints.children[this.stepsTaken].x, y: this.walkPoints.children[this.stepsTaken].y}, myGame.player.moveSpeed).start();
      walkTweens[1].to({x: this.walkPoints.children[this.stepsTaken].x, y: this.walkPoints.children[this.stepsTaken].y + myGame.outfit.bottom.location * (this.walkPlayerBody.scale.x*2)}, myGame.player.moveSpeed).start();
      walkTweens[2].to({x: this.walkPoints.children[this.stepsTaken].x, y: this.walkPoints.children[this.stepsTaken].y + myGame.outfit.top.location * (this.walkPlayerBody.scale.x*2)}, myGame.player.moveSpeed).start();
      walkTweens[3].to({x: this.walkPoints.children[this.stepsTaken].x, y: this.walkPoints.children[this.stepsTaken].y - myGame.outfit.hair.location * (this.walkPlayerBody.scale.x*2)}, myGame.player.moveSpeed).start();
      walkTweens[4].to({x: this.walkPoints.children[this.stepsTaken].x, y: this.walkPoints.children[this.stepsTaken].y + myGame.outfit.shoes.location * (this.walkPlayerBody.scale.x*2)}, myGame.player.moveSpeed).start();

      walkTweens[0].onComplete.add(function(){
        myGame.sounds.map.steps.stop();
        this.time.events.add(Phaser.Timer.SECOND/10, function(){
          this.checkPlayerLocation();
        }, this)}, this);
    }
    myGame.player.movable = false;
  },

  monitorTime: function(){
    if (myGame.day == 1 || myGame.day == 4) {
      var dayLocationText = "for school";
      var lateProblem = ". Your teacher won't be happy."
    } else if (myGame.day == 2 || myGame.day == 3) {
      var dayLocationText = "for work";
      var lateProblem = ". Your boss won't be happy."
    } else {
      var dayLocationText = "for your hangout with Renaud";
      var lateProblem = ", but that's okay."
    }

    if (myGame.player.lateToDayLocation) {
      this.timerText.setText("You\'re late " + dayLocationText + lateProblem);
      this.timerText.tint = 0xff1010;
    } else {
      if (myGame.timer.CurrentTime/myGame.timer.CountdownStart > .25) {
        this.timerText.setText("You\'re on time " + dayLocationText + ".");
      } else {
        this.timerText.setText("Hurry or you\'ll be late " + dayLocationText + "!");
        this.timerText.tint = 0xfff803;
      }
    }
  },

  showPlayerExclamation: function(){
    var currentStressNumber = myGame.player.stress;
    myGame.player.stress += 3;
    myGame.recentlyAddedStress += 3;
    myGame.updateStressMeter(currentStressNumber, myGame.player.stress);

    this.walkPlayerBody.loadTexture('baseCharacter_angry')
    myGame.sounds.map.catcaller.play();

    this.playerExclamation = this.walkPlayer.create(this.walkPlayerBody.x, this.walkPlayerBody.y - 80, 'playerExclamation');
    this.playerExclamation.anchor.setTo(0.5, 0);
    this.playerExclamation.animations.add("throb");
    this.playerExclamation.animations.play("throb", 10, true);

    this.playerExclamation.alpha = 0;
    var playerExclamationTween = game.add.tween(this.playerExclamation);

    playerExclamationTween.to( { alpha: 1 }, 100).to( { y: this.walkPlayerBody.y - 110 }, 400).to( { alpha: 0 }, 200).start();
    this.time.events.add(Phaser.Timer.SECOND, function(){
      this.playerExclamation.destroy();
    }, this);
  },

  continue: function () {
    // Set world bounds
    this.world.setBounds(0, 0, game.width, 1200);
    this.stage.backgroundColor = '#000000';
    if (myGame.timeOfDay == 'day') {
      this.state.start('MorningCommute');
    } else {
      this.state.start('HomeLate');
    }
  }
}